<?php
/*
Template Name: Password Reset Template
*/
global $wpdb, $user_ID;

function tg_validate_url() {
	global $post;
	$page_url = esc_url(get_permalink( $post->ID ));
	$urlget = strpos($page_url, "?");
	if ($urlget === false) {
		$concate = "?";
	} else {
		$concate = "&";
	}
	return $page_url.$concate;
}

if (!$user_ID) {
	if($_POST['action'] == "tg_pwd_reset"){

		$result = array("error" => 1,"msg" => "Unknone");

		if ( !wp_verify_nonce( $_POST['tg_pwd_nonce'], "tg_pwd_nonce")) {
			exit("No trick please");
		}
		if(empty($_POST['user_input'])) {
			echo "<div class='error'>Please enter your Username or E-mail address</div>";
			exit();
		}
		//We shall SQL escape the input
		$user_input = $wpdb->escape(trim($_POST['user_input']));

		if ( strpos($user_input, '@') ) {
			$user_data = get_user_by_email($user_input);
			if(empty($user_data) || $user_data->caps[administrator] == 1) { //delete the condition $user_data->caps[administrator] == 1, if you want to allow password reset for admins also
				echo "<div class='error'>Invalid E-mail address!</div>";
				exit();
			}
		} else {
			$user_data = get_userdatabylogin($user_input);
			if(empty($user_data) || $user_data->caps[administrator] == 1) { //delete the condition $user_data->caps[administrator] == 1, if you want to allow password reset for admins also
				echo "<div class='error'>Invalid Username!</div>";
				exit();
			}
		}

		$user_login = $user_data->user_login;
		$user_email = $user_data->user_email;

		$key = $wpdb->get_var($wpdb->prepare("SELECT user_activation_key FROM $wpdb->users WHERE user_login = %s", $user_login));
		if(empty($key)) {
			//generate reset key
			$key = wp_generate_password(20, false);
			$wpdb->update($wpdb->users, array('user_activation_key' => $key), array('user_login' => $user_login));
		}

		//mailing reset details to the user
		$message = __('Someone requested that the password be reset for the following account:') . "\r\n\r\n";
		$message .= get_option('siteurl') . "\r\n\r\n";
		$message .= sprintf(__('Username: %s'), $user_login) . "\r\n\r\n";
		$message .= __('If this was a mistake, just ignore this email and nothing will happen.') . "\r\n\r\n";
		$message .= __('To reset your password, visit the following address:') . "\r\n\r\n";
		$message .= tg_validate_url() . "action=reset_pwd&key=$key&login=" . rawurlencode($user_login) . "\r\n";

		if ( $message && !wp_mail($user_email, 'Password Reset Request', $message) ) {
			$result ["error"] = 1;
			$result ["msg"] = "Email failed to send for some unknown reason.";
		}
		else {
			$result ["error"] = 0;
			$result ["msg"] = "We have just sent you an email with Password reset instructions.";
		}

		echo json_encode($result);
		exit;

	} else if($_POST['action'] == "tg_pwd_new"){
		$result = array("error" => 1,"msg" => "Unknone");
		if ($_POST ['new_password'] == $_POST ['confirm_new_password'])  {
			$reset_key = $_POST['key'];
			$user_login = $_POST['login'];
			$user_data = $wpdb->get_row($wpdb->prepare("SELECT ID, user_login, user_email FROM $wpdb->users WHERE user_activation_key = %s AND user_login = %s", $reset_key, $user_login));


			$user_login = $user_data->user_login;
			$user_email = $user_data->user_email;

			wp_set_password( $_POST ['new_password'], $user_data->ID );

			$result ["error"] = 0;
			$result ["redect"] = get_site_url()."/login";

			$result ["msg"] = "Password changed. System will redect you to login page.";
		}else {
			$result ["error"] = 1;
			$result ["msg"] = "Password does not metch";
		}
		echo json_encode($result);
		exit;

	}else {
		get_header(); ?>
		<style>
			.isa_info,
			.isa_success,
			.isa_warning,
			.isa_error{margin: 10px 0px; padding: 5px;}
			.isa_info{color:#00529B;background-color:#BDE5F8;}
			.isa_success{color:#4F8A10;background-color:#DFF2BF;}
			.isa_warning{color:#9F6000;background-color:#FEEFB3;}
			.isa_error{color:#D8000C;background-color:#FFBABA;}
			.isa_info i,
			.isa_success i,
			.isa_warning i,
			.isa_error i{margin: 5px 5px; font-size: 16px; vertical-align: middle;}
		</style>
		<script src="//ajax.aspnetcdn.com/ajax/jquery.validate/1.9/jquery.validate.min.js" defer></script>
		<div class="clients_mainlist">
			<div class="page_ttl">
				<h2 class="ttlttl ttl_wth_srchng"> Login </h2> </div>
				<?php

				if(isset($_GET['key']) && $_GET['action'] == "reset_pwd") {
					$reset_key = $_GET['key'];
					$user_login = $_GET['login'];
					$user_data = $wpdb->get_row($wpdb->prepare("SELECT ID, user_login, user_email FROM $wpdb->users WHERE user_activation_key = %s AND user_login = %s", $reset_key, $user_login));


					$user_login = $user_data->user_login;
					$user_email = $user_data->user_email;

					if(!empty($reset_key) && !empty($user_data)) {
						?>
						<style>
							#wp_new_password {width: 300px; margin: auto; text-align: center;}
							#wp_new_password input {width: 100% !important;}
							input.reset_password { background: rgb(95, 79, 101); border: 0; color: #fff; cursor: pointer; display: inline; margin: 0; padding: 5px 23px; border-radius: 22px; }
							span.error { border: 0px !important; color: #F31212; }
						</style>
						<form class="user_form" id="wp_new_password" action="<?php echo get_permalink( $post->ID ); ?>" method="post">
							<input type="password" class="password" id="new_password" required name="new_password" placeholder="New Password" /><br />
							<input type="password" class="password" required id="confirm_new_password" name="confirm_new_password" placeholder="Confirm New Password" /><br />
							<input type="hidden" name="action" value="tg_pwd_new" />
							<input type="hidden" name="key" value="<?php echo $reset_key ?>" />
							<input type="hidden" name="login" value="<?php echo $user_login ?>" />
							<input type="submit" style="width: auto !important;" class="reset_password" name="submit" value="Reset Password" />
						</form>
						<div id="form-notify"></div> <!-- To hold validation results -->
						<script type="text/javascript">
							jQuery(document).ready(function($) {
								$('#wp_new_password').validate({
									errorElement: 'span',
									errorClass: 'error',
									focusInvalid: true,
									rules: {
										new_password: {
											required: true,
											minlength: 6
										},
										confirm_new_password:{
											required: true,
											equalTo: "#new_password",
											minlength: 6
										}
									},
									messages : {
										confirm_new_password: {
											equalTo: "Password does not metch."
										}
									}
								});
								$("#wp_new_password").on('submit', function(e) {
									e.preventDefault();
									var _that = $(this);

									if ( _that.valid() ){

										var _notify = $("#form-notify");
										var _submit = $(this).find("input[type='submit']");
										_notify.html('<div class="isa_info"> <i class="fa fa-info-circle"></i> Loding... </div>');
										_submit.prop('disabled', true);
										var $form = $(e.target);
										$.ajax({
											url: $form.attr('action'),
											type: 'POST',
											data: $form.serialize(),
											success: function(result) {
												try{
													var data = $.parseJSON(result);
													window.setTimeout(function(){
														if (data.hasOwnProperty('redect')) {
															window.location.href = data.redect;
														}
													},3000);

													if (data.error == 1) {
														_notify.html('<div class="isa_error"> <i class="fa fa-times-circle"></i>' + data.msg + '</div>');
														_submit.prop('disabled', false);
													} else {
														_notify.html('<div class="isa_success"><i class="fa fa-check"></i> ' + data.msg + ' </div>');
													}
												}catch(e){
													alert("An error occurred.");
													console.log(result);
													_submit.prop('disabled', false);
												}
											}
										});

									}
								});
});
</script>
<?php
} else {
	echo 'Not a Valid Key.';
};

} else {
	if ( have_posts() ) {
		while ( have_posts() ) {
			the_post();
			?>
			<style>
				#wp_pass_reset {width: 300px; margin: auto; text-align: center;}
				#wp_pass_reset input {width: 100% !important;}
				input.reset_password { background: rgb(95, 79, 101); border: 0; color: #fff; cursor: pointer; display: inline; margin: 0; padding: 5px 23px; border-radius: 22px; }
				span.error { border: 0px !important; color: #F31212; }
			</style>

			<form class="user_form" id="wp_pass_reset" action="<?php echo get_permalink( $post->ID ); ?>" method="post">
				<div style=" color: #fff; margin: 8px; ">Please enter your Email account</div>
				<input type="email" placeholder="Email"  name="user_input" /><br /><br />
				<input type="hidden" name="action" value="tg_pwd_reset" />
				<input type="hidden" name="tg_pwd_nonce" value="<?php echo wp_create_nonce("tg_pwd_nonce"); ?>" />
				<input type="submit" style="width: auto !important;" id="submitbtn" class="reset_password" name="submit" value="Reset Password" />
			</form>
			<div id="form-notify"></div> <!-- To hold validation results -->
			<script type="text/javascript">
				jQuery(document).ready(function($) {
					$('#wp_pass_reset').validate({
						errorElement: 'span',
						errorClass: 'error',
						focusInvalid: true						 
					});
					$("#wp_pass_reset").on('submit', function(e) {
						e.preventDefault();
						var _that = $(this);
						if ( _that.valid() ){

							var _notify = $("#form-notify");
							var _submit = $(this).find("input[type='submit']");
							_notify.html('<div class="isa_info"> <i class="fa fa-info-circle"></i> Loding... </div>');

							var $form = $(e.target);
							$.ajax({
								url: $form.attr('action'),
								type: 'POST',
								data: $form.serialize(),
								success: function(result) {
									try{
										var data = $.parseJSON(result);

										if (data.error == 1) {
											_notify.html('<div class="isa_error"> <i class="fa fa-times-circle"></i>' + data.msg + '</div>');
											_submit.prop('disabled', false);
										} else {
											_notify.html('<div class="isa_success"><i class="fa fa-check"></i> ' + data.msg + ' </div>');
										}
									}catch(e){
										alert("An error occurred.");
										console.log(result);
										_submit.prop('disabled', false);
									}
								}
							});
						}
					});
});
</script>

<?php
}
} else {
	?>

	<h1><?php _e('Not Found'); ?></h1>

	<?php
}
}
?>

</div>
</div><!-- #content -->
</div><!-- #primary -->
<?php

get_footer();
}
}
else {
	wp_redirect( home_url() ); exit;
		//redirect logged in user to home page
}
?>